//xsetaseta@gmail.com
//
//LTC6904 con arduino 1.8.5
//2020

/*
  I2C SDA (data line) = analog pin 4  ->CHIP SDI-pin2
  I2C SDC (clock line) = analog pin 5 ->CHIP SCK-pin3
  Resistencias de 1K a Vcc
*/

#define MODO_SETA 

#include <Wire.h>

#define LTC6904_ADDRESS 22  // CHIP pin ADR(4)<-VCC

#include <TM1638.h>
// define a module on data pin 8, clock pin 9 and strobe pin 7
TM1638 module(8, 9, 7);

byte display[8];
char cadena[20];

int frecu1=0;
int frecu0=0;
long frecux=1;

char parpadeo=4;


void setFreqSETA(long freq) //HZ
{
 int z;
 long frecu;
 long mipo;
 unsigned int oct;

    frecu=freq;
    for(z=0;z<16;z++)
      {      
        if(frecu>1038 && frecu<2078) break;
        frecu/=2;
      }

  oct =z;
  mipo=2;
  for(z=1;z<oct+10;z++)    mipo*=2;

  unsigned int dac =  2048 - (2078 *mipo) / freq;
  Serial.print(oct); Serial.print("<-oct SETA  dac->");Serial.println(dac);
      
  unsigned int reg = oct << 12 | dac << 2 ;
   
  byte high = (reg >> 8) & 0xff;
  byte low = reg & 0xff;
   
  Wire.beginTransmission(LTC6904_ADDRESS);
  Wire.write(high);
  Wire.write(low);
  Wire.endTransmission();  
}
 


void setFreq(float freq, boolean compOutputOn=true) 
{
  unsigned int oct = (int) (3.322*log10(freq * 1000.0 / 1039.0));
  unsigned int dac = (int) (2048.0 - 2078.0 * pow(2, 10 + oct) / (freq * 1000.0) + 0.5);

  Serial.print(oct); Serial.print("<-oct X dac->");Serial.println(dac);
     
  unsigned int cnf = compOutputOn ? 0 : 2; 
  unsigned int reg = oct << 12 | dac << 2 | cnf;
   
  byte high = (reg >> 8) & 0xff;
  byte low = reg & 0xff;
   
  Wire.beginTransmission(LTC6904_ADDRESS);
  Wire.write(high);
  Wire.write(low);
  Wire.endTransmission();  
}





void printDisplay(long z)
{
  sprintf(cadena,"%08li",z);
  module.setDisplayToString(cadena,0,0);
}

void setup() 
{
  Serial.begin(9600);

  Wire.begin(); // We're I2C-Bus Master
  module.setupDisplay(1,0);
  Serial.println("INICIO");
  printDisplay(frecux);
}

void loop() 
{
  byte keys;
  int z;
  float frecuxf;
  
  keys = module.getButtons();
  
  switch(keys)
  {
   case 1:
      display[0]++; if(display[0]>9) display[0]=0;
   break; 
   case 2:
      display[1]++; if(display[1]>9) display[1]=0;
   break; 
   case 4:
      display[2]++; if(display[2]>9) display[2]=0;
   break; 
   case 8:
      display[3]++; if(display[3]>9) display[3]=0;
   break; 

   case 16:
      display[4]++; if(display[4]>9) display[4]=0;
   break; 
   case 32:
      display[5]++; if(display[5]>9) display[5]=0;
   break; 
   case 64:
      display[6]++; if(display[6]>9) display[6]=0;
   break; 
   case 128:
      display[7]++; if(display[7]>9) display[7]=0;
   break; 

  }

  
    if (keys>0)
     {
      parpadeo=10;
     //Serial.println(keys);
     frecu1=display[0]*1000+display[1]*100+display[2]*10+display[3];  
     frecu0=display[4]*1000+display[5]*100+display[6]*10+display[7];
     
     frecux=(long)frecu1*10000 +frecu0;
     

     printDisplay(frecux);
 //    delay(100);
    }


  if(parpadeo<2)
    {
      if(parpadeo==1)
        {
          if(frecux<1039)
            {
              frecux=1039;
              display[4]=1;  display[5]=0; display[6]=3;  display[7]=9;
              display[0]=0;  display[1]=0; display[2]=0;  display[3]=0;
              printDisplay(frecux);
            }
    
         if(frecux>68000000)
            {
              frecux=68000000;
              display[4]=0;  display[5]=0; display[6]=0;  display[7]=0;
              display[0]=6;  display[1]=8; display[2]=0;  display[3]=0;
              printDisplay(frecux);
            }
          parpadeo=0;
          frecuxf=frecux;
          frecuxf/=1000;
#ifdef MODO_SETA                  
          setFreqSETA(frecux);
#else
          setFreq(frecuxf);
#endif           
          Serial.print("FRECUENCIA="); Serial.println(frecux);
        }
    }
    else
    {
      parpadeo--;
      delay(100);
      module.setLEDs(128);
      delay(100);
      module.setLEDs(0);
    }

 delay(10);
  
}
